package com.logicbig.example;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import java.util.List;

public class ExampleMain2 {

    public static void main(String[] args) {
        EntityManagerFactory emf = Persistence.createEntityManagerFactory("example-unit");
        try {
            persistEntity(emf);
            runNativeQueries(emf);
            loadEntity(emf);
        } finally {
            emf.close();
        }
    }

    private static void persistEntity(EntityManagerFactory emf) {
        System.out.println("-- Persisting entities --");
        EntityManager em = emf.createEntityManager();

        ClassA a = new ClassA();
        a.setMyInt(10);
        a.setMyStr("a test String");

        ClassB b = new ClassB();
        b.setMyStrB("a test string in ClassB");
        b.setClassARef(a);

        MyEntity entityB = new MyEntity();
        entityB.setClassBRef(b);

        System.out.println(entityB);

        em.getTransaction().begin();
        em.persist(entityB);
        em.getTransaction().commit();
        em.close();
    }

    private static void runNativeQueries(EntityManagerFactory emf) {
        System.out.println("-- native queries --");
        EntityManager em = emf.createEntityManager();
        ExampleMain.nativeQuery(em, "Select * from MyEntity");
    }

    private static void loadEntity(EntityManagerFactory emf) {
        System.out.println("-- Loading MyEntity --");
        EntityManager em = emf.createEntityManager();
        List<MyEntity> entityList = em.createQuery("Select t from MyEntity t")
                                      .getResultList();
        entityList.forEach(System.out::println);
        em.close();
    }
}